Imports Microsoft.VisualBasic
#Region "Copyright Syncfusion Inc. 2001 - 2015"
' Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
' Use of this code is subject to the terms of our license.
' A copy of the current license can be obtained at any time by e-mailing
' licensing@syncfusion.com. Any infringement will be prosecuted under
' applicable laws. 
#End Region
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Grid
Imports System.IO

Namespace DataTable_Transpose
	Partial Public Class Form1
		Inherits Form
		Private dataSet As DataSet
		Public Sub New()
			InitializeComponent()
			dataSet = New DataSet()

'			#Region "GDBG LookAndFeel"
			Me.gridDataBoundGrid1.DefaultRowHeight = 18
			Me.gridDataBoundGrid1.DefaultColWidth = 70
'			#End Region

'			#Region "Initial Data"
			Me.CreateTable()
			Me.gridDataBoundGrid1.DataSource = Me.GDBC1Table
'			#End Region
		End Sub

		#Region "Properties"
		'These properties are used to maintain the DataSource
		Private _GDBC1Table As DataTable
		Public Property GDBC1Table() As DataTable
			Get
				Return _GDBC1Table
			End Get
			Set(ByVal value As DataTable)
				_GDBC1Table = value
			End Set
		End Property

		Private _GDBC2Table As DataTable
		Public Property GDCB2Table() As DataTable
			Get
				Return _GDBC2Table
			End Get
			Set(ByVal value As DataTable)
				_GDBC2Table = value
			End Set
		End Property
		#End Region

		#Region "Initial DataSource"
		''' <summary>
		''' Default datasource
		''' </summary>
		Private Sub CreateTable()
			ReadXml(dataSet, "GDBDdata.XML")
			Me.gridDataBoundGrid1.DataSource = dataSet.Tables("Products")
			Me.GDBC1Table = dataSet.Tables("Products")

		End Sub
		#End Region

		Private Sub ReadXml(ByVal ds As DataSet, ByVal xmlFileName As String)
			For n As Integer = 0 To 9
				If System.IO.File.Exists(xmlFileName) Then
					ds.ReadXml(xmlFileName)
					Exit For
				End If
				xmlFileName = "..\" & xmlFileName
			Next n
		End Sub

		#Region "Transpose DataSource"
		''' <summary>
		''' Used to tranpose the grid datasource
		''' </summary>
		Private Sub CreateTable2()
			'Creating the Temporary DataTable
			Dim _GdcTable As New DataTable()

			'Creating the columns 
			For i As Integer = 0 To Me.GDBC1Table.Rows.Count - 1
				_GdcTable.Columns.Add("Sample" & i)
			Next i

			Dim colCount As Integer = Me.gridDataBoundGrid1.Model.ColCount

			'Generating the data for transposed grid.
			For c As Integer = 1 To colCount
				Dim dr As DataRow = _GdcTable.NewRow()
				For rowIndex As Integer = 1 To Me.GDBC1Table.Rows.Count - 1
					dr(rowIndex - 1) = Me.gridDataBoundGrid1.Model(rowIndex, c).CellValue
				Next rowIndex

				_GdcTable.Rows.Add(dr)
			Next c

			'Assigning the datasource
			Me._GDBC2Table = _GdcTable
		End Sub
		#End Region

		#Region "Events"

		Private Sub Model_QueryRowCount(ByVal sender As Object, ByVal e As GridRowColCountEventArgs)
			e.Count = Me.GDBC1Table.Columns.Count
			e.Handled = True
		End Sub

		Private Sub Model_QueryCellInfo(ByVal sender As Object, ByVal e As GridQueryCellInfoEventArgs)
			'Used to set the row header names
			If e.ColIndex = 0 AndAlso e.RowIndex > 0 Then
				e.Style.CellType = "Header"
				e.Style.CellValue = Me.GDBC1Table.Columns(e.RowIndex - 1).ColumnName
			End If

			'Used to hide the column header text when grid is tranposed
			If e.RowIndex = 0 AndAlso e.ColIndex > 0 Then
				e.Style.CellValue = String.Empty
			End If
		End Sub

		Private Sub transposeBtn_Click(ByVal sender As Object, ByVal e As EventArgs) Handles transposeBtn.Click

			'To hide the column headers for look and feel
			Me.gridDataBoundGrid1.ShowColumnHeaders = False


			'To set the RowHeader cellvalues as column names
			AddHandler gridDataBoundGrid1.Model.QueryCellInfo, AddressOf Model_QueryCellInfo

			'Maintaining the RowCount
			AddHandler gridDataBoundGrid1.Model.QueryRowCount, AddressOf Model_QueryRowCount

			'Generating the DataSource (Transposing the DataSource)
			Me.CreateTable2()

			'Assigning the Transposed datasource
			Me.gridDataBoundGrid1.DataSource = Me._GDBC2Table

			'To set RowHeader width
			Me.gridDataBoundGrid1.Model.ColWidths.ResizeToFit(GridRangeInfo.Table())
		End Sub
		#End Region       

	End Class
End Namespace